/*
 * SaveBuddy
 *
 * Copyright (C) 2000 Mohammad A. Haque <mhaque@haque.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
 * USA
 */

#define GAIM_PLUGINS

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include "gaim.h"

void *handle;

/* based on do_export in src/dialogs.c */
void savebuddy(void) {
	FILE *file;
	char *saveFile = g_malloc(BUF_LEN);
	char *buf = g_malloc(BUF_LONG);	
	
	saveFile[0] = '\0';
	strcat(saveFile,getenv("HOME"));
	strcat(saveFile,"/.gaim/savebuddy");
	
	toc_build_config(buf,BUF_LONG - 1);
	
	if(strlen(buf) > 15)
		if((file = fopen(saveFile,"w"))) {
			fprintf(file,"%s\n",buf);
			fclose(file);
			chmod(buf,S_IRUSR | S_IWUSR);
		} else {
			g_snprintf(buf,BUF_LONG / 2,"Error writing file %s",saveFile);
			do_error_dialog(buf,"Error");
		}
}

void gaim_plugin_init(void *h) {
	handle = h;
	
	gaim_signal_connect(handle,event_signoff,savebuddy,NULL);
}

char *name() {
	return "SaveBuddy Version 0.1";
}

char *description() {
	return "Saves a local copy of your buddylist to ~/.gaim/savebuddy when you quit.";
}
